//--------------------------------------
// CompressorList.cpp
// Jason Hughes
// Origin Systems
// 1998
//--------------------------------------

#include "first.h"
#include "CompressorList.h"

//--------------------------------------

u_int32         CompressorList::count;
CompressorList *CompressorList::list;

//--------------------------------------

CompressorList::CompressorList(void)
{
	next=NULL;
	compressor=NULL;
}

CompressorList::~CompressorList(void)
{
	delete compressor;
	compressor=NULL;
}

//--------------------------------------

void CompressorList::install(void)
{
	list=NULL;
	count=0;
}

void CompressorList::remove(void)
{
	while (list)
	{
		CompressorList *tmp;
		tmp=list;
		list=list->next;
		delete tmp;
	}
	count=0;
}

void CompressorList::addCompressor(Compressor *newCompressor)
{
	CompressorList *link;

	link=NEW CompressorList;
	link->next=list;
	link->compressor=newCompressor;
	list=link;

	count++;
}

Compressor *CompressorList::getCompressorByIndex(u_int32 index)
{
	CompressorList *walker;

	walker=list;
	while (walker && index && walker->next)
	{
		index--;
		walker=walker->next;
	}

	return walker->compressor;
}

u_int32 CompressorList::getCompressorCount(void)
{
	return count;
}

Compressor *CompressorList::getCompressorByType(CompressorTypes id)
{
	CompressorList *walker;

	walker=list;
	while (walker && walker->compressor->enumerate()!=id)
		walker=walker->next;

	if (walker)
		return walker->compressor;
	return NULL;
}

CompressorTypes CompressorList::getBestCompressor(const CompressorInput &in)
{
	DecompressorInput out;
	CompressorTypes bestType=CT_RawCompressor;
	u_int32         bestSize=4000000000;
	CompressorList *walker;

	walker=list;
	while (walker)
	{
		walker->compressor->compress(in,&out);

		if (out.lengthInBytes<bestSize)
		{
			bestSize=out.lengthInBytes;
			bestType=walker->compressor->enumerate();
		}

		walker=walker->next;
		delete []out.buffer;
		out.buffer=NULL;
		out.lengthInBytes=0;
	}

	return bestType;
}
